<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader
        :is-auth="true"
        :is-statuser="true"
        powerData="newly_added_terminal_button"
        @addForm="addForm"
      >
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">区域设置</div>
          </div>
        </template></Minheader
      >
      <div class="app-containers">
        <DataTable
          :tableHeader="tableCols"
          :tableData="tableData"
          :tableBtnGroup="tableBtnGroup"
          :tableProperty="{ rowKey: 'ID' }"
          @btnClick="btnClick"
        />
      </div>
      <Dialog
        :flag="flag"
        :type="type"
        :msgTitle="msgTitle"
        :delName="tableForm.terminalName"
        @resetForm="resetForm"
        @delRest="delRest"
        @submitForm="submitForm"
        @delRemove="delRemove"
      >
        <div class="diacont">
          <el-form
            :model="tableForm"
            :rules="formRules"
            ref="airportInfoChildForm"
          >
            <el-row :gutter="24">
              <el-col>
                <el-form-item
                  label="区域名称"
                  size="default"
                  prop="terminalName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.terminalName"
                    placeholder="请输入区域名称"
                  />
                </el-form-item>
              </el-col>
              <!-- <el-col>
                <el-form-item
                  label="区域编码"
                  size="default"
                  prop="terminalID"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.terminalID"
                    placeholder="请输入区域编码"
                  />
                </el-form-item>
              </el-col> -->
              <!-- <el-col>
                <el-form-item
                  label="机场三字码"
                  size="default"
                  prop="airportCode"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    disabled
                    v-model="tableForm.airportCode"
                    placeholder="请输入机场三字码"
                  />
                </el-form-item>
              </el-col> -->
              <el-col>
                <el-form-item label="机场名称" size="default">
                  <el-input
                    disabled
                    v-model="tableForm.abbreviation"
                    placeholder="请输入机场名称"
                  />
                </el-form-item>
              </el-col>
              <el-col :span="24">
                <el-form-item label="备注" size="default">
                  <el-input
                    type="textarea"
                    v-model="tableForm.remarks"
                    placeholder="请输入备注"
                  />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
import Cookies from "js-cookie";
const formRules = useElement().formRules;
const router = useRouter();
const route = useRoute();
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<Boolean>(false);
const rowTitle = ref<String>("");
const tableCols = ref([]); //表头数据
const serviceId = ref<String>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<Boolean>(false); //弹窗开关
const type = ref<String>(""); //判断是否删除
const msgTitle = ref<String>("新增区域"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗
const tableBtnGroup = ref<Array>([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "terminal_editing_button",
  },
  {
    name: "位置设置",
    className: "editBtn",
    param: 4,
    is: "position_setting_page",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "terminal_deletion_button",
  },
]); //单独的编辑
const tableForm = reactive({
  terminalID: "",
  terminalName: "",
  airportCode: "",
  abbreviation: "",
  remarks: "",
  event: "",
}); //弹窗内容
//列表
const tableData = ref([]);
//表头
const state = reactive({
  list: [
    { label: "ID", key: "name" },
    { label: "名称", key: "china" },
    { label: "机场三字码", key: "englin" },
  ],
  listLoading: true,
});
tableForm.airportCode = route.query.IATACode
  ? route.query.IATACode
  : Cookies.get("IATACode");
tableForm.abbreviation = route.query.abbreviation
  ? route.query.abbreviation
  : Cookies.get("abbreviation");
// tableForm.airportCode = route.query.IATACode;
// tableForm.abbreviation = route.query.abbreviation;
//新增
const addForm = () => {
  msgTitle.value = "新增区域";
  tableForm.event = 1;
  flag.value = true;
  type.value = "";
};
//取消
const resetForm = () => {
  flag.value = false;
  tableForm.terminalID = "";
  tableForm.terminalName = "";
  tableForm.remarks = "";
};
//编辑
const editDialog = (data) => {
  msgTitle.value = "编辑区域";
  flag.value = true;
  type.value = "";
  tableForm.name = data.name;
  tableForm.china = data.china;
  tableForm.englin = data.englin;
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除区域";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
//删除取消
const delRest = () => {
  flag.value = false;
};
//位置跳转
const aloneDialog = () => {
  router.push({ path: "/BasicsData/positionSetting" });
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑区域";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.terminalID = index.terminalID;
    tableForm.terminalName = index.terminalName;
    tableForm.airportCode = index.airportCode;
    tableForm.remarks = index.remarks;
  } else if (param === 3) {
    msgTitle.value = "删除区域";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.terminalID = index.terminalID;
    tableForm.terminalName = index.terminalName;
    tableForm.airportCode = index.airportCode;
  } else if (param === 4) {
    router.push({
      path: "/BasicsData/positionSetting",
      query: {
        terminalID: index.terminalID,
        terminalName: index.terminalName,
      },
    });
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.terminalTableId,
      needPage: ++page.value,
      dataContent: [
        route.query.IATACode ? tableForm.airportCode : Cookies.get("IATACode"),
      ],
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableData.value.forEach((element) => {
        element.abbreviation = tableForm.abbreviation
          ? tableForm.abbreviation
          : Cookies.get("abbreviation");
      });
      tableCols.value = returnData.columnSet;
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
//确认提交
const airportInfoChildForm: any = ref(null);
const submitForm = () => {
  airportInfoChildForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    let obj = {
      IATACode: tableForm.airportCode,
    };
    data = {
      ...data,
      ...obj,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 100px;
}
</style>
